#!/usr/bin Rscript

#Call the script like this: Rscript distance_matrix.R firm4_1_filt_shared_fraction.txt firm4_1_dist_matrix.txt

#data acquisition. The script assumes the output as generated by the script shared_var.pl (which contains the jaccard index in the fourth column ("shared_fraction"). The jaccard distance is 1-"jaccard index"

Args <- commandArgs(trailingOnly=TRUE)
argument <- Args[1]
data <- read.table(argument,h=T)#, check.names=FALSE)
outfile_name <- Args[2]

#Calculate the jaccard distance
jaccard_dist <- 1-data$Shared_fraction
data_new <- cbind(data, jaccard_dist)

#Create a distance matrix from the data, and print it out

samples <- levels(data_new$Sample1)
nb_samples <- length(samples)
sample_index <- c(1:nb_samples)
matrix_zeros <- rep(0, nb_samples*nb_samples)
dist_matrix <- matrix(matrix_zeros, nrow=nb_samples, ncol=nb_samples)
rownames(dist_matrix) <- samples
colnames(dist_matrix) <- samples

for (i in sample_index) {
    for (j in sample_index) {
        if (samples[i] == samples[j]) {
	     	dist_matrix[i,j] = 0
        }
	else {
	    data_line <- subset(data_new, data_new$Sample1 == samples[i] & data_new$Sample2 == samples[j]) 
	    dist_matrix[i,j] = data_line$jaccard_dist
        }
     }
}

write.table(dist_matrix,file=outfile_name,row.names=TRUE,col.names=NA,quote=FALSE,sep="\t")
